# class KConfigBackEnd | KDE Configuration file loading/saving abstract base class. More...
Contains pure virtuals
Definition | `#include <kconfigbackend.h>`
Inherited by | KConfigDBMBackEnd, KConfigINIBackEnd
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- KConfigBackEnd (KConfigBase *_config, const QString &_fileName, const char * _resType, bool _useKDEGlobals)
- virtual ~KConfigBackEnd ()
- virtual bool parseConfigFiles ()
- virtual void sync (bool bMerge = true)
- void changeFileName (const QString &_fileName, const char * _resType, bool _useKDEGlobals)
- virtual KConfigBase::ConfigState getConfigState () const
- QString filename () const
- const char * resource () const
- void setLocaleString (const QCString &_localeString)

#### Protected Members

- KConfigBase *pConfig
- QString fileName
- QCString resType
- bool useKDEGlobals
- QCString localeString
- KConfigBackEndPrivate *d

## Detailed Description

Abstract base class for KDE configuration file loading/saving.

This class forms the base for all classes that implement some manner of loading/saving to configuration files. It is an abstract base class, meaning that you cannot directly instantiate objects of this class. As of right now, the only back end available is one to read/write to INI-style files, but in the future, other formats may be available, such as XML or a database.

KConfigBackEnd (KConfigBase *_config, const QString &_fileName, const char * _resType, bool _useKDEGlobals) | ### KConfigBackEnd

Construct a configuration back end.

Parameters:

_config | Specifies the configuration object which values will be passed to as they are read, or from where values to be written to will be obtained from.
_fileName | The name of the file in which config data is stored. All registered configuration directories will be looked in in order of decreasing relevance.
_resType | the resource type of the fileName specified, _if_ it is not an absolute path (otherwise this parameter is ignored).
_useKDEGlobals | If true, the user's system-wide kdeglobals file will be imported into the config object. If false, only the filename specified will be dealt with.

~KConfigBackEnd () | ### ~KConfigBackEnd

[virtual]

Destructor.

bool parseConfigFiles () | ### parseConfigFiles

[pure virtual]

Parse all configuration files for a configuration object. This method must be reimplemented by the derived classes.

Returns: Whether or not parsing was successful.

void sync (bool bMerge = true) | ### sync

[pure virtual]

Write configuration data to file(s). This method must be reimplemented by the derived classes.

Parameters:

bMerge | Specifies whether the old config file already on disk should be merged in with the data in memory. If true, data is read off the disk and merged. If false, the on-disk file is removed and only in-memory data is written out.

void changeFileName (const QString &_fileName, const char * _resType, bool _useKDEGlobals) | ### changeFileName

change the filenames associated with this back end. You should probably reparse your config info after doing this.

Parameters:

_fileName | the new filename to use
_resType | the resource type of the fileName specified, _if_ it is not an absolute path (otherwise this parameter is ignored).
_useKDEGlobals | specifies whether or not to also parse the global KDE configuration files.

KConfigBase::ConfigState getConfigState () | ### getConfigState

[const virtual]

Retrieve the state of the app-config object.

See also: KConfig::getConfigState

QString filename () | ### filename

[const]

Returns: the filename as passed to the constructor.

const char * resource () | ### resource

[const]

Returns: the resource type as passed to the constructor.

void setLocaleString (const QCString &_localeString) | ### setLocaleString

KConfigBase * pConfig | ### pConfig

[protected]

QString fileName | ### fileName

[protected]

QCString resType | ### resType

[protected]

bool useKDEGlobals | ### useKDEGlobals

[protected]

QCString localeString | ### localeString

[protected]

KConfigBackEndPrivate * d | ### d

[protected]

- Version: $Id: kconfigbackend.h,v 1.14 2000/09/25 03:53:04 waba Exp $
- Author: Preston Brown <pbrown@kde.org>, Matthias Kalle Dalheimer <kalle@kde.org>
- Generated: root@sparc.ports.openbsd.org on Wed May 2 09:34:58 2001, using kdoc 2.0a53.